
class Intro extends GameMode {

  int newHeight;

  Intro() {
    if (aspectRatio != 1.6) {
      intro.resize(width, height);
    } else {
      newHeight = ScreenHeight/10*9;
      intro.resize(ScreenWidth, newHeight);
    }
  }


  void draw() {
    if (aspectRatio == 1.6) {
      background(0);
      image(intro, 0, (ScreenHeight-newHeight)/2);
    } else {
      background(intro);
    }


    textAlign(CENTER);
    textSize(25);
    fill(125);
    text("klicke um fortzufahren", ScreenWidth/2, ScreenHeight-15); //just a text to visualize that the current Game Mode is Intro
  }

  void mouseClicked() {
    gameMode = new PlayMode(); //sets the gameMode to PlayMode
  }
}
